#import "XeeNSImageLoader.h"



@implementation XeeNSImage

-(id)initWithFile:(NSString *)name firstBlock:(NSData *)block attributes:(NSDictionary *)attributes view:(XeeView *)targetview;
{
	if(self=[super initWithFile:name firstBlock:block attributes:attributes view:targetview])
	{
		NSImage *image=[[[NSImage alloc] initWithContentsOfFile:name] autorelease];

		if(image)
		{
//			width=;
///			height=;
//			depth=;
			[self setFormat:[[filename pathExtension] uppercaseString]];

			NSArray *images=[XeeNSImage convertRepresentations:[image representations] view:targetview];
			if(images)
			{
				[subimages addObjectsFromArray:images];

				return self;
			}
		}

		[self release];
		return nil;
	}

	return self;
}

-(void)dealloc
{
	[super dealloc];
}

-(BOOL)load
{
	return YES;
}

-(BOOL)loaded
{
	return YES;
}

+(NSArray *)convertRepresentations:(NSArray *)representations view:(XeeView *)targetview
{
	NSMutableArray *images=[NSMutableArray arrayWithCapacity:[representations count]];
	NSEnumerator *enumerator=[representations objectEnumerator];
	NSBitmapImageRep *rep;

	while(rep=[enumerator nextObject])
	{
		if([rep class]!=[NSBitmapImageRep class]) break;
		if([rep isPlanar]) break;

		int format=[rep respondsToSelector:@selector(bitmapFormat)]?[rep bitmapFormat]:0;
		int type,depth;

		switch([rep bitsPerPixel])
		{
			case 8:
				type=XeeBitmapTypeLuma8;
				depth=40;
			break;

			case 24:
				type=XeeBitmapTypeRGB24;
				depth=24;
			break;

			case 32:
				if(format&NSAlphaFirstBitmapFormat) type=XeeBitmapTypeARGB32;
				else type=XeeBitmapTypeBGRA32;
				depth=[rep samplesPerPixel]*8;
			break;

			default: type=0; break;
		}

		if(type)
		{
			XeeBitmapImage *image=[[[XeeBitmapImage alloc] initWithData:[rep bitmapData] type:type
			width:[rep pixelsWide] height:[rep pixelsHigh] bytesPerRow:[rep bytesPerRow] view:targetview] autorelease];

			if(image)
			{
				if([rep samplesPerPixel]==4)
				{
					[image setTransparent:YES];
					[image setBackgroundColor:[NSColor whiteColor]];
				}

				[image setDepth:depth];
				[image setDataSource:rep];
				if(!(format&NSAlphaNonpremultipliedBitmapFormat)) [image setPremultiplied:YES];

				[image buildTextures];

				[images addObject:image];
			}
		}
	}

	return images&&[images count]?images:nil;
}

+(NSArray *)fileTypes { return [NSBitmapImageRep imageFileTypes]; }

@end

/*
		@"ico", // Windows Icon

		@"crw", // Camera Raw
		@"cr2",
		@"nef",
		@"raf",
		@"orf",
		@"mrw",
		@"srf",
		@"dcr",
		@"'CRW '",
		@"'CR2 '",
		@"'NEF '",

		@"dng", // Digital Negative
		@"'DNG '",

		@"xbm", // X Bitmap
		@"'XBM '",

		@"exr", // OpenEXR
		@"'exr '",
		@"'EXR '",

		@"fax", // Fax Document
		@"jfx",
		@"jfax",

		@"icns", // Mac OS Icons

		@"pic", // Radiance
		@"hdr",
*/