#import <Cocoa/Cocoa.h>

@class XeeImage,XeeController;

@interface XeeView:NSOpenGLView
{
	XeeImage *image;
	NSTimer *scrolltimer;

	int width,height;
	int imgwidth,imgheight;
	float zoom;

	bool up,down,left,right;
	int x,y;

	IBOutlet XeeController *controller;
}

-(void)setImage:(XeeImage *)img zoom:(float)startzoom;
-(void)setImage:(XeeImage *)img zoom:(float)startzoom frame:(int)frame;
-(void)setImageFrame:(int)frame;
-(void)updateImage;
-(void)startScrolling;
-(void)stopScrolling;
-(void)scroll:(NSTimer *)timer;
-(NSPoint)focus;
-(void)setFocus:(NSPoint)focus;
-(void)clampCoords;
-(float)zoom;
-(void)setZoom:(float)newzoom;
-(void)setViewSize:(NSSize)size focus:(NSPoint)focus;
-(NSSize)maxViewSize;
-(NSSize)drawerSize;
-(void)lock;
-(void)unlock;

@end
